本帖最后由 ning58 于 2016-1-22 08:47 编辑
此图是本人在Solidworks官网的API板块发的帖。
解决问题是统计全孔和半孔的数据。

How to count hole number include half hole | SOLIDWORKS Forums
https://forum.solidworks.com/thread/108191
我的提出的关键码是
Set SwLoop = swFace.GetFirstLoop Do While Not SwLoop Is Nothing
If Not SwLoop.IsOuter Then vEdges = SwLoop.GetEdges If UBound(vEdges) = 0 Then Dim swEdge As SldWorks.Edge Set swEdge = vEdges(0) Dim swCurve As SldWorks.Curve Set swCurve = swEdge.GetCurve 'If swCurve.IsCircle Then totalHolesCount = totalHolesCount + 1 'End If End If End If
老外给我提出的优化代码,与我的代码没什么区别,只是代码编制习惯。
Private Sub ll()
Dim Xls As Excel.Application, Rng As Range
Set Xls = GetObject(, "Excel.Application")
Set Rng = Xls.Cells(3, 1)
Dim yDict As New Dictionary, xx(), yy(), oArr
Dim SwApp As SldWorks.SldWorks, SwModel As ModelDoc2
Set SwApp = Application.SldWorks
Set SwModel = SwApp.ActiveDoc
Dim SwSelMgr As SelectionMgr
Set SwSelMgr = SwModel.SelectionManager
Dim SwFeat As Feature, Total As Integer
Set SwFeat = SwSelMgr.GetSelectedObject5(1)
Dim fCount, vFace, SwFace As Face2
Dim SwEdgePt, SwEdge As Edge, vEdge
Dim SwSketch As Sketch, SwCurve As Curve
''
vFace = SwFeat.GetFaces
fCount = SwFeat.GetFaceCount
ReDim xx(fCount), yy(fCount)
For ii = 0 To UBound(vFace)
Set SwFace = vFace(ii)
With SwFace
vEdge = .GetEdges
Set SwEdge = vEdge(0)
With SwEdge
Set SwCurve = .GetCurve
ss = SwCurve.CircleParams
xx(ii) = Round(ss(0) * 1000, 2)
yy(ii) = Round(ss(2) * 1000, 1)
Rng(ii, 1) = xx(ii)
Rng(ii, 2) = yy(ii)
yDict(yy(ii)) = ""
End With
End With
Next ii
oArr = Bubble_Sort(yDict.Keys, "ASC")
Dim yCount()
ReDim yCount(UBound(oArr), 1)
For ii = 0 To UBound(oArr)
'Debug.Print Xls.WorksheetFunction.CountIf(yy, oArr(ii))
cc = 0
For jj = 0 To UBound(yy)
If oArr(ii) = yy(jj) Then
cc = cc + 1
End If
Next jj
yCount(ii, 0) = oArr(ii)
yCount(ii, 1) = cc
Total = Total + cc
Next ii
Debug.Print Total
Stop
End Sub
''
''
''
Function Bubble_Sort(Ary, objOrder As String)
Dim aryUBound, i, j
aryUBound = UBound(Ary)
For ii = 0 To aryUBound
Ary(ii) = Val(Round(Ary(ii), 2))
Next ii
For i = 0 To aryUBound
For j = i + 1 To aryUBound
Select Case UCase(objOrder)
Case "DESC"
If Ary(i) < Ary(j) Then
Swap Ary(i), Ary(j)
End If
Case "ASC"
If Ary(i) > Ary(j) Then
Swap Ary(i), Ary(j)
End If
End Select
Next
Next
Bubble_Sort = Ary
End Function
''
Function Swap(a, B)
Dim tmp
tmp = a
a = B
B = tmp
End Function
|